> For the complete documentation index, see [llms.txt](https://docs.midpointapi.com/midpoint-documentation/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.midpointapi.com/midpoint-documentation/core-concepts/midpoints/sources.md).

# Sources

Every midpoint has a Source that initiates a request. Midpoint sources specify exactly how an off-chain workflow begins, and passes any relevant data related to the request to downstream tasks.&#x20;

**Startpoint Called**

Startpoint Called is used to trigger a midpoint from on-chain by making a call to the `callMidpoint` function in a Midpoint-deployed contract. Startpoint Called is used when creating oracles, data bridges, or any other workflow that begins with a contract on chain 'initiating' the workflow. For more information about Startpoint Called sources, go to [Startpoint Called](/midpoint-documentation/sources/startpoint-called.md).

```json
{
    "startpointCalledSource": {
        "whitelist": [
            {
                "chainId": "",
                "contractAddress": ""
            }
        ],
        "variables": [
            {
                "name": "",
                "datatype": ""
            }
        ],
        "extracts": [
            {
                "name": "",
                "from": ""
            }
        ],
        "excludeLogs": []
    }
}
```

**EVM Event Emitted**

EVM Event Emitted is used to trigger a midpoint whenever an on-chain event is emitted. These can be any event from a contract currently deployed on-chain, and does not have to go through [Startpoints](/midpoint-documentation/more-reading/startpoints.md). When configuring an EVM Event Emitted source, you can specify indexed parameters, and particular values to listen for, if you want to listen for filtered events. EVM Event Emitted is used when creating alerts, listeners, data bridges, or any other workflow that begins with a contract on chain performing a particular action. For more information about the EVM Event Emitted task, go to [EVM Event Emitted](/midpoint-documentation/sources/evm-event-emitted.md).

```json
{
    "evmEventEmittedSource": {
        "chainId": "",
        "contractAddress": "",
        "eventName": "",
        "arguments": [
            {
                "name": "",
                "datatype": "",
                "indexed": false,
                "value": ""
            }
        ],
        "extracts": [
            {
                "name": "",
                "from": ""
            }
        ],
        "excludeLogs": []
    }
}
```

**Cron Job Triggered**

Cron Job Triggered is used to trigger a midpoint by following a crontab. This can be used to trigger a midpoint at a regular interval, such as every every minute, every thirty minutes, every hour, every week, or every month. Cron Job Triggered is used when creating price feeds, alerts, or any workflow that requires a regular execution of a midpoint. For more information about Cron Job Triggered, go to [Cron Job Triggered](/midpoint-documentation/sources/cron-job-triggered.md).

```json
{
    "cronJobTriggeredSource": {
        "crontab": "",
        "extracts": [
            {
                "name": "",
                "from": ""
            }
        ],
        "excludeLogs": []
    }
}
```

Sources have several common fields with [Tasks](/midpoint-documentation/core-concepts/midpoints/tasks.md). These components are outlined in [Source and Task Definitions](/midpoint-documentation/core-concepts/midpoints/source-and-task-definitions.md).

Don't see a Source that you need for your off-chain workflow? Get in touch.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.midpointapi.com/midpoint-documentation/core-concepts/midpoints/sources.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
